/*
 * Copyright (C) 2008
 * Robert Bosch LLC
 * Research and Technology Center North America
 * Palo Alto, California
 *
 * All rights reserved.
 *
 *------------------------------------------------------------------------------
 * project ....: PUMA: Probablistic Unsupervised Model Acquisition
 * file .......: BoundingBox.h
 * authors ....: Benjamin Pitzer
 * organization: Robert Bosch LLC
 * creation ...: 07/25/2006
 * modified ...: $Date:2008-06-02 19:31:25 -0700 (Mon, 02 Jun 2008) $
 * changed by .: $Author:benjaminpitzer $
 * revision ...: $Revision:298 $
 */
#ifndef BOUNDINGBOX_H
#define BOUNDINGBOX_H

//== INCLUDES ==================================================================
#include <vector>
#include "rtc/rtcTriMesh.h"

//== NAMESPACES ================================================================
namespace rtc {

//== CLASS DEFINITION ==========================================================
class BoundingBox
{
public:
   BoundingBox() {};
  ~BoundingBox() {};

  /**
  * computes the oriented rectangular bounding box for the given
  * mesh.
  *
  * @return true if successful, false otherwise.
  */
  bool apply(const TriMesh& mesh, Point& bbMin, Point& bbMax);

  /**
  * computes the oriented rectangular bounding box for the given
  * meshes.
  *
  * @return true if successful, false otherwise.
  */
  bool apply(const std::vector<TriMesh*> meshes, Point& bbMin, Point& bbMax);

};

//==============================================================================
} // NAMESPACE puma
//==============================================================================
#endif // BOUNDINGBOX_H defined
//==============================================================================
