/*
 * Copyright (C) 2009
 * Robert Bosch LLC
 * Research and Technology Center North America
 * Palo Alto, California
 *
 * All rights reserved.
 *
 *------------------------------------------------------------------------------
 * project ....: Autonomous Technologies
 * file .......: rtcException.h
 * authors ....: Benjamin Pitzer
 * organization: Robert Bosch LLC
 * creation ...: 04/14/2008
 * modified ...: $Date: 2009-01-26 13:06:31 -0800 (Mon, 26 Jan 2009) $
 * changed by .: $Author: kls1pal $
 * revision ...: $Revision: 23 $
 */
#ifndef RTCBASE_EXCEPTION_H_
#define RTCBASE_EXCEPTION_H_

#include <string>

//== NAMESPACES ================================================================
namespace rtc {

	// Base class for all exceptions.
class Exception
{
public:
  // standard c'tor/d'tor
  Exception(const std::string& error = std::string());
  virtual ~Exception();

  // get error message
  const std::string& getErrorMessage() const;
  const std::string& what() const;

protected:
  std::string errorMessage;
};

//==============================================================================
} // NAMESPACE rtc
//==============================================================================
#endif // RTCBASE_EXCEPTION_H_ defined
//==============================================================================

