/*
 * Copyright (C) 2008
 * Robert Bosch LLC
 * Research and Technology Center North America
 * Palo Alto, California
 *
 * All rights reserved.
 *
 *------------------------------------------------------------------------------
 * project ....: PUMA: Probablistic Unsupervised Model Acquisition
 * file .......: Face3D.h
 * authors ....: Zhexi Wang
 * organization: Robert Bosch LLC
 * creation ...: 03/28/2008
 * modified ...: $Date:2008-03-03 10:26:02 -0800 (Mon, 03 Mar 2008) $
 * changed by .: $Author:benjaminpitzer $
 * revision ...: $Revision:141 $
 */
#ifndef FACE3D_H_
#define FACE3D_H_

//== INCLUDES ==================================================================
#include <rtc/rtcBase.h>
#include <rtc/rtcVec3.h>

//== NAMESPACES ================================================================
namespace rtc {

//== FORWARD DECLARATIONS ======================================================
class Mesh3D;

//== CLASS DEFINITION ==========================================================
class Face3D
{
public:
  // standard c'tor and d'tor
  Face3D(Mesh3D* mesh, int v0, int v1, int v2);
  virtual ~Face3D();
  // copy c'tor
  Face3D(const Face3D& other);

  // calculate face normal
  void update();

  // ASCII stream IO
  virtual bool write(OutputHandler &oh) const;
  virtual bool read(InputHandler &ih);
  void write(FILE *fp) const;
  void read(FILE *fp);

  // flags
  void setFlag(int flags, bool value);
  bool getFlag(int flags) const;
  bool boundary() const;
  void setBoundary(bool boundary);
  bool hidden() const;
  void setHidden(bool hidden);

  // internal data
  Mesh3D* mesh;
  // face vertices
  Vec3i v;
  // face normal
  Vec3f n;
  // multi purpose flags
  int flags;
};

//==============================================================================
} // NAMESPACE rtc
//==============================================================================
#endif // FACE3D_H_ defined
//==============================================================================
