#include <string>
#include <vector>

//== NAMESPACES ================================================================
namespace rtc {

// struct variable to store OpenGL info
struct GLInfo
{
    std::string vendor;
    std::string renderer;
    std::string version;
    std::vector <std::string> extensions;
    int redBits;
    int greenBits;
    int blueBits;
    int alphaBits;
    int depthBits;
    int stencilBits;
    int maxTextureSize;
    int maxLights;
    int maxAttribStacks;
    int maxModelViewStacks;
    int maxProjectionStacks;
    int maxClipPlanes;
    int maxTextureStacks;

    // ctor, init all members
    GLInfo() : redBits(0), greenBits(0), blueBits(0), alphaBits(0), depthBits(0),
               stencilBits(0), maxTextureSize(0), maxLights(0), maxAttribStacks(0),
               maxModelViewStacks(0), maxClipPlanes(0), maxTextureStacks(0) {}

    bool getInfo();                             // extract info
    void printSelf();                           // print itself
    bool isExtensionSupported(const char* ext); // check if a extension is supported
};

//==============================================================================
} // namespace rtc
//==============================================================================
