/*
 * Copyright (C) 2009
 * Robert Bosch LLC
 * Research and Technology Center North America
 * Palo Alto, California
 *
 * All rights reserved.
 *
 *------------------------------------------------------------------------------
 * project ....: Autonomous Technologies
 * file .......: rtcIOObject.h
 * authors ....: Benjamin Pitzer
 * organization: Robert Bosch LLC
 * creation ...: 10/16/2006
 * modified ...: $Date: 2009-01-21 18:19:16 -0800 (Wed, 21 Jan 2009) $
 * changed by .: $Author: benjaminpitzer $
 * revision ...: $Revision: 14 $
 */
#ifndef RTC_IOOBJECT_H
#define RTC_IOOBJECT_H

//== INCLUDES ==================================================================
#include <rtc/rtcInputHandler.h>
#include <rtc/rtcOutputHandler.h>

//== NAMESPACES ================================================================
namespace rtc {

/**
 * Base input/output class for for data objects.
 */
class IOObject {
public:
  /// default constructor
  IOObject();
  /// destructor
  virtual ~IOObject();
  /// write IOObject to OutputHandler
  virtual bool write(OutputHandler& oh) const = 0;
  /// read IOObject from InputHandler
  virtual bool read(InputHandler& ih) = 0;
  /// read IOObject from a file
  virtual bool readFromFile(InputHandler& ih, const char* filename);
  /// write the IOObject to a file
  virtual bool writeToFile(OutputHandler& oh, const char* filename);
};

//==============================================================================
} // namespace rtc
//==============================================================================
#endif // RTC_IOOBJECT_H defined
//==============================================================================

