/*
 * Copyright (C) 2008
 * Robert Bosch LLC
 * Research and Technology Center North America
 * Palo Alto, California
 *
 * All rights reserved.
 *
 *------------------------------------------------------------------------------
 * project ....: PUMA: Probablistic Unsupervised Model Acquisition
 * file .......: MeshSet3DHelper.h
 * authors ....: Benjamin Pitzer
 * organization: Robert Bosch LLC
 * creation ...: 04/20/2008
 * modified ...: $Date:2008-03-03 10:26:02 -0800 (Mon, 03 Mar 2008) $
 * changed by .: $Author:benjaminpitzer $
 * revision ...: $Revision:141 $
 */
#ifndef MESHSET3DHELPER_H_
#define MESHSET3DHELPER_H_

//== INCLUDES ==================================================================
#include <rtc/rtcVec2.h>
#include <rtc/rtcVec4.h>
#include "rtc/rtcMeshSet3D.h"

//== NAMESPACES ================================================================
namespace rtc {

//== CLASS DEFINITION ==========================================================
class MeshSet3DHelper
{
public:
  // standard c'tor and d'tor
  MeshSet3DHelper();
  virtual ~MeshSet3DHelper();

  // add noise
  static void addMotionNoise(MeshSet3D& meshset, Vec4f& alpha);
  static void addMeasurementNoise(MeshSet3D& meshset, Vec3f& alpha_measurement);
  // mean distance of vertices
  static float meanDistance(const MeshSet3D& meshset1, const MeshSet3D& meshset2);
  /**
   * remove isolated vertices
   *
   * This method removes isolated vertices which are not connected to
   * any triangle.
   */
  static void removeIsolatedVertices(MeshSet3D& srcdest);
};

//==============================================================================
} // NAMESPACE rtc
//==============================================================================
#endif // MESHSET3DHELPER_H_ defined
//==============================================================================
