/*
 * Copyright (C) 2009
 * Robert Bosch LLC
 * Research and Technology Center North America
 * Palo Alto, California
 *
 * All rights reserved.
 *
 *------------------------------------------------------------------------------
 * project ....: Autonomous Technologies
 * file .......: rtcStringTools.h
 * authors ....: Benjamin Pitzer
 * organization: Robert Bosch LLC
 * creation ...: 04/16/2007
 * modified ...: $Date: 2009-01-21 18:19:16 -0800 (Wed, 21 Jan 2009) $
 * changed by .: $Author: benjaminpitzer $
 * revision ...: $Revision: 14 $
 */
#ifndef RTC_STRINGTOOLS_H
#define RTC_STRINGTOOLS_H

//== INCLUDES ==================================================================
#include <string>
#include <vector>

//== NAMESPACES ================================================================
namespace rtc {

/// converts a string to a bool
bool lexical_cast_bool(const std::string& str, const bool bDefault = false);
/// converts a string to an integer
int lexical_cast_int(const std::string& str, const int nDefault = 0);
/// converts a string to a float
float lexical_cast_float(const std::string& str, const float fDefault = 0.0f);
/// converts a string to a double
double lexical_cast_double(const std::string& str, const double dDefault = 0.0);
/// converts a string to a long
long lexical_cas_long(const std::string& str, const long lDefault = 0);
/// converts a double to a string
std::string lexical_cast_string(const double& var);
/// converts a float to a string
std::string lexical_cast_string(const float& var);
/// converts a bool to a string
std::string lexical_cast_string(const bool& var);
/// converts an integer to a string
std::string lexical_cast_string(const int& var);
/// split string into a number of tokens
void split_string(const std::string& str, std::vector<std::string>& tokens, const std::string& delimiters = " ");
/// trim leading an trailing spaces
std::string& trim(std::string& str);

//==============================================================================
} // NAMESPACE rtc
//==============================================================================
#endif // RTC_STRINGTOOLS_H defined
//==============================================================================
