/*
 * Copyright (C) 2009
 * Robert Bosch LLC
 * Research and Technology Center North America
 * Palo Alto, California
 *
 * All rights reserved.
 *
 *------------------------------------------------------------------------------
 * project ....: Autonomous Technologies
 * file .......: rtcException.cpp
 * authors ....: Benjamin Pitzer
 * organization: Robert Bosch LLC
 * creation ...: 04/14/2008
 * modified ...: $Date: 2009-01-26 13:06:31 -0800 (Mon, 26 Jan 2009) $
 * changed by .: $Author: kls1pal $
 * revision ...: $Revision: 23 $
 */

//== INCLUDES ==================================================================
#include "rtc/rtcException.h"

//== NAMESPACES ================================================================
namespace rtc {

Exception::Exception(const std::string& error)
{
  errorMessage = error;
}

Exception::~Exception(void)
{
}

const std::string& Exception::getErrorMessage() const
{
  return errorMessage;
}

const std::string& Exception::what() const
{
  return errorMessage;
}

//==============================================================================
} // namespace rtc
//==============================================================================
