/*
 * Copyright (C) 2009
 * Robert Bosch LLC
 * Research and Technology Center North America
 * Palo Alto, California
 *
 * All rights reserved.
 *
 *------------------------------------------------------------------------------
 * project ....: Autonomous Technologies
 * file .......: rtcIOObject.cpp
 * authors ....: Benjamin Pitzer
 * organization: Robert Bosch LLC
 * creation ...: 10/16/2006
 * modified ...: $Date: 2009-01-21 18:19:16 -0800 (Wed, 21 Jan 2009) $
 * changed by .: $Author: benjaminpitzer $
 * revision ...: $Revision: 14 $
 */

//== INCLUDES ==================================================================
#include <stdio.h>
#include <fstream>
#include <iostream>
#include <string>
#include "rtc/rtcIOObject.h"

//== NAMESPACES ================================================================
namespace rtc {

//== IMPLEMENTATION ============================================================

// default constructor
IOObject::IOObject()
{
}

// destructor
IOObject::~IOObject()
{
}

bool IOObject::readFromFile(InputHandler& ih, const char* filename)
{
  bool res;
  std::fstream fin;
  if(ih.binary()) fin.open(filename,std::ios::in|std::ios::binary);
  else fin.open(filename,std::ios::in);
  if (fin.is_open()) {
    ih.use(fin);
    res = read(ih);
  } else {
    return false;
  }
  fin.close();
  return res;
}

bool IOObject::writeToFile(OutputHandler& oh, const char* filename)
{
  bool res;
  std::fstream fout;
  if(oh.binary()) fout.open(filename,std::ios::out|std::ios::binary);
  else fout.open(filename,std::ios::out);
  if (fout.is_open()) {
    oh.use(fout);
    res = write(oh);
  } else {
    return false;
  }
  fout.close();
  return res;
}

//==============================================================================
} // namespace rtc
//==============================================================================
