/*
 * Copyright (C) 2009
 * Robert Bosch LLC
 * Research and Technology Center North America
 * Palo Alto, California
 *
 * All rights reserved.
 *
 *------------------------------------------------------------------------------
 * project ....: Autonomous Technologies
 * file .......: rtcInputHandler.cpp
 * authors ....: Benjamin Pitzer
 * organization: Robert Bosch LLC
 * creation ...: 01/20/2009
 * modified ...: $Date: 2009-01-21 18:19:16 -0800 (Wed, 21 Jan 2009) $
 * changed by .: $Author: benjaminpitzer $
 * revision ...: $Revision: 14 $
 */

//== INCLUDES =================================================================
#include "rtc/rtcInputHandler.h"

//== NAMESPACES ===============================================================
namespace rtc {

//== IMPLEMENTATION ==========================================================

/// default constructor
InputHandler::InputHandler()
: inStream(NULL)
{
}

/// construct from istream
InputHandler::InputHandler(std::istream& is)
: inStream(&is)
{
}

/// destructor
InputHandler::~InputHandler()
{
  inStream = NULL;
}

void InputHandler::use(std::istream& is)
{
  inStream = &is;
}

/// returns a reference to the stream
std::istream& InputHandler::stream()
{
  return *inStream;
}

/// Check if the state of the stream is good for i/o operations.
bool InputHandler::good() const
{
  if(!inStream) return false;
  return inStream->good();
}

//=============================================================================
} // namespace rtc
//=============================================================================
