#include "rtc/rtcMath.h"

#ifdef _WIN32
#include <sys/timeb.h>
#include <windows.h>
#define M_PI 3.14159265358979323846
#else
#include <sys/time.h>
#endif



namespace rtc{
#ifdef _WIN32
  void rtc_seed_rand(void) {
    SYSTEMTIME SystemTime; GetSystemTime(&SystemTime);
    unsigned int n = int(SystemTime.wSecond*1000000 + SystemTime.wMilliseconds); std::srand(n);
  }
#else
  void rtc_seed_rand(void) {
    timeval tv; gettimeofday(&tv,NULL);
    unsigned int n = int(tv.tv_sec*1000000 + tv.tv_usec); std::srand(n);
  }
#endif

}