/*
 * Copyright (C) 2009
 * Robert Bosch LLC
 * Research and Technology Center North America
 * Palo Alto, California
 *
 * All rights reserved.
 *
 *------------------------------------------------------------------------------
 * project ....: Autonomous Technologies
 * file .......: rtcOutputHandler.cpp
 * authors ....: Benjamin Pitzer
 * organization: Robert Bosch LLC
 * creation ...: 10/16/2006
 * modified ...: $Date: 2009-01-21 18:19:16 -0800 (Wed, 21 Jan 2009) $
 * changed by .: $Author: benjaminpitzer $
 * revision ...: $Revision: 14 $
 */

//== INCLUDES =================================================================
#include "rtc/rtcOutputHandler.h"

//== NAMESPACES ===============================================================
namespace rtc {

//== IMPLEMENTATION ===========================================================

/// default constructor
OutputHandler::OutputHandler()
: outStream(NULL)
{
}

/// construct from ostream
OutputHandler::OutputHandler(std::ostream& os)
: outStream(&os)
{
}

/// destructor
OutputHandler::~OutputHandler()
{
  outStream = NULL;
}

void OutputHandler::use(std::ostream& os)
{
  outStream = &os;
}

/// returns a reference to the stream
std::ostream& OutputHandler::stream()
{
  return *outStream;
}

/// Check if the state of the stream is good for i/o operations.
bool OutputHandler::good() const
{
  if(!outStream) return false;
  return outStream->good();
}

//=============================================================================
} // namespace rtc
//=============================================================================
